# $Id: bigbrother.spec 351 2006-01-25 13:45:21Z rpmbuild $

%define bbver 19c
%define BBHOME %([ $BBHOME ] && echo $BBHOME || echo "/opt/bb" )
%define BBUSER %([ $BBUSER ] && echo $BBUSER || echo "bb" )
%define BBFQDN %([ $BBFQDN ] && echo $BBFQDN || echo "TRUE" )
%define BBDISPLAY %([ $BBDISPLAY ] && echo $BBDISPLAY || echo "www.localhost" )
%define BBPAGER %([ $BBPAGER ] && echo $BBPAGER || echo "pager.localhost" )
%define DEFAULTPAGE %([ $DEFAULTPAGE ] && echo $DEFAULTPAGE || echo "root@localhost" )
%define BBWEB %([ $BBWEB ] && echo $BBWEB || echo "/bb" )
%define CGIBIN %([ $CGIBIN ] && echo $CGIBIN || echo "/var/www/cgi-bin" )
%define CGIBINURL %([ $CGIBINURL ] && echo $CGIBINURL || echo "/cgi-bin" )
%define WEBROOT %([ $WEBROOT ] && echo $WEBROOT || echo "/var/www/html" )
%define HTTPUSER %([ $HTTPUSER ] && echo $HTTPUSER || echo "apache" )


Summary: Monitor your system and network with Big Brother
Name: bigbrother
Version: 1.9c
Release: %RErelease 16
Epoch: 0
License: Better-Than-Free
Group: System Environment/Daemons
URL: http://www.bb4.org/
Source0: http://bb4.org/dnld/bb-%{version}.tar.gz
Source1: bbconfig
Source2: bigbrother.init
Source3: bigbrother.sysconfig
Source4: bigbrother.logrotate
Source5: README.RPM
Source6: bigbrother.apache
Source7: BigBrother.pm
Patch0: bb%{bbver}.Makefile.patch
Patch1: bb%{bbver}.bbvar.patch
Patch2: bb%{bbver}.bbout.patch
Patch3: bb%{bbver}.bbtmp.patch
Patch4: bb%{bbver}.bbsys.local.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Prefix: %{_prefix}
Requires: bash, sed, gawk
Requires: coreutils, procps, findutils, iputils
NoSource: 0

%description
The Big Brother System & Network Monitor consists of simple shell
scripts which periodically monitor system conditions and network
connectivity.  Disk space, CPU, servers, and important processes can
be kept track of.

Big Brother can notify administrators via a pager or e-mail.

%package server
Summary: Additional files for a Big Brother server machine
Group: System Environment/Daemons
Requires: bigbrother = %{version}-%{release}, bind-utils, lynx, mailx, webserver
#Requires: ckermit, qpage, sendpage
BuildRequires: bind-utils

%description server
The Big Brother System & Network Monitor consists of simple shell
scripts which periodically monitor system conditions and network
connectivity.  Disk space, CPU, servers, and important processes can
be kept track of.

Big Brother can notify administrators via a pager or e-mail.

These are the additional Big Brother files for using this machine as a
BBDISPLAY, BBNET, or BBPAGER host.

%package extras
Summary: Additional extras for a Big Brother host
Group: Networking/Utilities
Requires: bigbrother = %{version}-%{release}
BuildRequires: perl

%description extras
These are additional goodies from http://www.deadcat.net/

%prep
%setup -c -q
%{__tar} xf bb%{bbver}.tar
cd bb%{bbver}
%patch0
%patch1
%patch2
%patch3
%patch4

%build
cd bb%{bbver}
BBHOME=%BBHOME STOPROOT=TRUE BBUSER=%BBUSER BBFQDN=%BBFQDN \
BBDISPLAY=%BBDISPLAY BBPAGER=%BBPAGER DOWEB=TRUE DOPAGE=TRUE \
DEFAULTPAGE=%DEFAULTPAGE BBWEB=%BBWEB CGIBIN=%CGIBIN CGIBINURL=%CGIBINURL \
sh %{SOURCE1} redhat
cd src
%{__make}
 
%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
cd bb%{bbver}/src
%{__make} install
%{__mv} ../etc/bb-hosts ../etc/bb-hosts.DIST
cd ..
%{__sed} 's:^BBTMP.*$:BBTMP="%{_localstatedir}/opt/bbvar/tmp":' etc/bbdef.sh \
  > tmp/bbdef.sh
%{__mv} tmp/bbdef.sh etc/bbdef.sh
cd ..

%{__mkdir_p} ${RPM_BUILD_ROOT}%{CGIBIN}
for script in bb-hist.sh bb-histlog.sh bb-ack.sh bb-hostsvc.sh bb-rep.sh bb-replog.sh; do
  %{__cat} bb%{bbver}/web/${script}.DIST | \
  %{__sed} "s!&&BBHOME!%{BBHOME}!1" > bb%{bbver}/tmp/${script}.$$
  %{__mv} bb%{bbver}/tmp/${script}.$$ ${RPM_BUILD_ROOT}%{CGIBIN}/${script}
  %{__chmod} 555 ${RPM_BUILD_ROOT}%{CGIBIN}/${script}
done

%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/init.d \
             ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig \
             ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d \
             ${RPM_BUILD_ROOT}%{BBHOME} \
             ${RPM_BUILD_ROOT}%{_localstatedir}/opt \
             ${RPM_BUILD_ROOT}%{_localstatedir}/www/html
%{__cp} -p %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/init.d/bigbrother
%{__sed} -e 's:&BBHOME:%{BBHOME}:' -e 's:&BBUSER:%{BBUSER}:' %{SOURCE3} \
  > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/bigbrother
%{__sed} 's:&BBOUT:%{_localstatedir}/opt/bbvar/BBOUT:' %{SOURCE4} \
  > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/bigbrother
%{__mv} bbvar/ ${RPM_BUILD_ROOT}%{_localstatedir}/opt/bbvar/
%{__mkdir} ${RPM_BUILD_ROOT}%{_localstatedir}/opt/bbvar/tmp/
rmdir ${RPM_BUILD_ROOT}%{BBHOME}
%{__cp} -a bb%{bbver}/ ${RPM_BUILD_ROOT}%{BBHOME}/
%{__cp} -p %{SOURCE5} ${RPM_BUILD_ROOT}%{BBHOME}/README.RPM
%{__rm} -rf ${RPM_BUILD_ROOT}%{BBHOME}/install
%{__rm} -rf ${RPM_BUILD_ROOT}%{BBHOME}/src
OPWD=`pwd`
cd ${RPM_BUILD_ROOT}%{BBHOME}
%{__rm} README LICENSE README.CHANGES README.INSTALL README.SECURITY \
        README.SUPPORT FILES.LIST runbb.sh.DIST etc/bbwarnrules.cfg.DIST \
        etc/bbchkwarnrules.sh.DIST
find ${RPM_BUILD_ROOT} -name .helloworld -exec rm {} \;
cd $OPWD
##
%{__ln_s} %{BBHOME}/www ${RPM_BUILD_ROOT}%{WEBROOT}/bb
##%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d
##%{__sed} -e 's:&BBHOME:%{BBHOME}:' -e 's:&BBWEB:%{BBWEB}:' %{SOURCE6} \
##  > ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/bigbrother.conf

# extras
%{__mkdir_p} ${RPM_BUILD_ROOT}%perl_sitelib
%{__install} -m 0644 %{SOURCE7} ${RPM_BUILD_ROOT}%perl_sitelib
#

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT
 
%pre
# Add the bb user if there is not one
getent passwd %{BBUSER} >/dev/null 2>&1
if [ $? -ne 0 ]; then
 /usr/sbin/groupadd -g 103 %{BBUSER}
 /usr/sbin/useradd -r -u 103 -g %{BBUSER} -c "Big Brother" -M -d %{BBHOME} %{BBUSER}
fi

%post
/sbin/chkconfig --add bigbrother
/bin/chgrp %{BBUSER} /var/log/messages
/bin/chmod g+r /var/log/messages
 
%preun
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service bigbrother stop > /dev/null 2>&1
  /sbin/chkconfig --del bigbrother
fi
 
%postun
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service bigbrother condrestart > /dev/null 2>&1
else
 /usr/sbin/userdel %{BBUSER} 2>/dev/null || :
 /usr/sbin/groupdel %{BBUSER} 2>/dev/null || :
 /bin/chgrp root /var/log/messages
 /bin/chmod g-r /var/log/messages
fi
 
%files
%defattr(-,root,root)
%doc bb%{bbver}/LICENSE bb%{bbver}/README bb%{bbver}/README.CHANGES
%doc bb%{bbver}/README.INSTALL bb%{bbver}/README.SECURITY
%doc bb%{bbver}/README.SUPPORT
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/bigbrother
%attr(0755,root,root) %{_sysconfdir}/init.d/bigbrother
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/bigbrother

%{BBHOME}/runbb.sh
%{BBHOME}/README.RPM

%{BBHOME}/bin/bb
%{BBHOME}/bin/bb-combo.sh
%{BBHOME}/bin/bb-cpu.sh
%{BBHOME}/bin/bb-disk.sh
%{BBHOME}/bin/bb-local.sh
%{BBHOME}/bin/bb-msgs.sh
%{BBHOME}/bin/bb-procs.sh
%{BBHOME}/bin/bbrun
%{BBHOME}/bin/bbrun.old
%{BBHOME}/bin/getipaddr
%{BBHOME}/bin/getipaddr.sh
%{BBHOME}/bin/touchtime

%{BBHOME}/etc/bb-bbexttab.DIST
%{BBHOME}/etc/bbchkcfg.sh
%{BBHOME}/etc/bbchkcmds.sh
%{BBHOME}/etc/bbchkhosts.sh
%{BBHOME}/etc/bb-cputab.DIST
%config %{BBHOME}/etc/bbdef.sh
%{BBHOME}/etc/bbdef.sh.DIST
%{BBHOME}/etc/bb-dftab.DIST
%{BBHOME}/etc/bb-hosts.DIST
%config %{BBHOME}/etc/bbinc.sh
%{BBHOME}/etc/bb-msgstab.DIST
%{BBHOME}/etc/bb-proctab.DIST
%config %{BBHOME}/etc/bbsys.local
%{BBHOME}/etc/bbsys.sh
%config %{BBHOME}/etc/bbwarnsetup.cfg

%{BBHOME}/ext/

%defattr(-,%{BBUSER},%{BBUSER})
%dir %{_localstatedir}/opt/bbvar/
%dir %{_localstatedir}/opt/bbvar/tmp/

%files server
%defattr(-,root,root)
%{BBHOME}/bin/bb-display.sh
%{BBHOME}/bin/bb-mailack.sh
%{BBHOME}/bin/bb-network.sh
%{BBHOME}/bin/bb-ping.sh
%{BBHOME}/bin/bbd
%{BBHOME}/bin/bbmv
%{BBHOME}/bin/bbnet
%{BBHOME}/bin/bbprune
%{BBHOME}/bin/bbrm
%{BBHOME}/bin/bbstat
%{BBHOME}/bin/dumphostsvc
%{BBHOME}/bin/sendmsg
%{BBHOME}/bin/sendsms

%{BBHOME}/etc/bbchkwarnrules.sh
%config %{BBHOME}/etc/bbwarnrules.cfg
%config %{BBHOME}/etc/numeric-k6.scr
%config %{BBHOME}/etc/numeric.scr
%{BBHOME}/etc/security.DIST
%config %{BBHOME}/etc/sms.scr

%config %{BBHOME}/web/*_footer
%config %{BBHOME}/web/*_header
%{BBHOME}/web/mk*
%{BBHOME}/web/*.DIST
%{BBHOME}/web/*.sh

%attr(-,%{BBUSER},%{BBUSER}) %dir %{BBHOME}/www/
%{BBHOME}/www/gifs-bb13/
%{BBHOME}/www/gifs/
%{BBHOME}/www/help/
%attr(-,%{BBUSER},%{BBUSER}) %dir %{BBHOME}/www/html/
%attr(-,%{BBUSER},%{BBUSER}) %dir %{BBHOME}/www/notes/
%{BBHOME}/www/notes/README
%{BBHOME}/www/notes/www.bb4.com.html
%{BBHOME}/www/psy/
%attr(0775,%{HTTPUSER},%{HTTPUSER}) %dir %{BBHOME}/www/rep/

##%attr(0644,root,root) %config %{_sysconfdir}/httpd/conf.d/bigbrother.conf
##
%{WEBROOT}/bb
%{CGIBIN}
%defattr(-,%{BBUSER},%{BBUSER})
%{_localstatedir}/opt/bbvar/

%files extras
%defattr(-,root,root)
%perl_sitelib

%changelog
* Sun Dec 11 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.9c-16
- Rebuilt in new build system.

* Sat Jul 09 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.9c-15
- Changed DFEXCLUDE in bbsys.local to now exclude /mnt and /media.

* Mon Jul 05 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.9c-14
- Marked $BBHOME/web/*[_header|_footer] as %config.
- Made bigbrother-server and bigbrother-extras rely on the same version and
  release of the base bigbrother package.
- Added BuildRequires of bind-utils for bigbrother-server.

* Mon Jun 27 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.9c-13
- Fixed error in logrotate script.
- Cleaned up init script.
- Added -P to bbsys.local DF patch.

* Sun Jun 26 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.9c-12
- Added patch to fix ext/mkbb/* scripts to use $BBTMP and not $BBHOME/tmp.
- Fixed up the bigbrother-server specfile definition.

* Sun May 01 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Fixed URL for Source0.
- Moved BBTMP to /var.

* Fri Apr 29 2005 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Added NoSource since we are not allowed to redistribute source or binaries.
- Changed Group.

* Sun Dec 26 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Added use of getent instead of using grep.

* Mon Apr 12 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Added BigBrother.pm to bigbrother-extras package.

* Tue Apr 06 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Added WEBROOT to the build-time options.
- Globally converted /var/www/cgi-bin to CGIBIN.
- Added missing subdirectories to BBVAR.

* Mon Apr 05 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- Fixes to %pre and %postun to add/remove bb user.
- Fixes to Requires.
- Moved touchtime from bigbrother-server to main bigbrother package.
- Added bb read permissions to /var/log/messages.
- Fixed stop section of bigbrother init script to not throw "FAILED".
- Moved $BBHOME/ext from bigbrother-server to main bigbrother package.

* Mon Mar 22 2004 RazorsEdge Packaging <rpmpackaging@razorsedge.org>
- First package.

